@ img (CvMat*, CvArr*, void*, IplImage*)
#define CV_IS_IMAGE_HDR(img)     ((img) != NULL && ((const IplImage*)(img))->nSize == sizeof(IplImage))
#define CV_IS_IMAGE(img)     (CV_IS_IMAGE_HDR(img) && ((IplImage*)img)->imageData != NULL)
@ row int
@ col int
@ image IplImage*
@ elemtype (byte, short, ...)
#define CV_IMAGE_ELEM( image, elemtype, row, col )     (((elemtype*)((image)->imageData + (image)->widthStep*(row))[(col)]))
@ flags int
#define CV_MAT_CN(flags)        ((((flags) & CV_MAT_CN_MASK) >> 3) + 1)
#define CV_MAT_DEPTH(flags)     ((flags) & CV_MAT_DEPTH_MASK)
#define CV_MAT_TYPE(flags)      ((flags) & CV_MAT_TYPE_MASK)
#define CV_MAT_FMT(flags)       ((flags) & CV_MAT_FMT_MASK)
#define CV_IS_MAT_CONT(flags)   ((flags) & CV_MAT_CONT_FLAG)
#define CV_IS_TEMP_MAT(flags)   ((flags) & CV_MAT_TEMP_FLAG)
@ mat (CvMat*, CvArr*, void*)
@ (mat1, mat2) CvMat*
#define CV_IS_MAT_HDR(mat)     ((mat) != NULL && (((const CvMat*)(mat))->type & CV_MAGIC_MASK) == CV_MAT_MAGIC_VAL)
#define CV_IS_MAT(mat)     (CV_IS_MAT_HDR(mat) && ((const CvMat*)(mat))->data.ptr != NULL)
#define CV_IS_MASK_ARR(mat)     (((mat)->type & (CV_MAT_TYPE_MASK & ~CV_8SC1)) == 0)
#define CV_ARE_TYPES_EQ(mat1, mat2)     ((((mat1)->type ^ (mat2)->type) & CV_MAT_TYPE_MASK) == 0)
#define CV_ARE_CNS_EQ(mat1, mat2)     ((((mat1)->type ^ (mat2)->type) & CV_MAT_CN_MASK) == 0)
#define CV_ARE_DEPTHS_EQ(mat1, mat2)     ((((mat1)->type ^ (mat2)->type) & CV_MAT_DEPTH_MASK) == 0)
#define CV_ARE_SIZES_EQ(mat1, mat2)     ((mat1)->height == (mat2)->height && (mat1)->width == (mat2)->width)
#define CV_IS_MAT_CONST(mat)     (((mat)->height|(mat)->width) == 1)
#define CV_ELEM_SIZE(type)     (CV_MAT_CN(type) << ((0xe90 >> CV_MAT_DEPTH(type)*2) & 3))
#define CV_MAT_ELEM_PTR_FAST( mat, row, col, pix_size )     (assert( (unsigned)(row) < (unsigned)(mat).rows &&              (unsigned)(col) < (unsigned)(mat).cols ),      (mat).data.ptr + (size_t)(mat).step*(row) + (pix_size)*(col))
#define CV_MAT_ELEM_PTR( mat, row, col )     CV_MAT_ELEM_PTR_FAST( mat, row, col, CV_ELEM_SIZE((mat).type) )
#define CV_MAT_ELEM( mat, elemtype, row, col )     (*(elemtype*)CV_MAT_ELEM_PTR_FAST( mat, row, col, sizeof(elemtype)))
#define CV_IS_MATND_HDR(mat)     ((mat) != NULL && (((const CvMatND*)(mat))->type & CV_MAGIC_MASK) == CV_MATND_MAGIC_VAL)
#define CV_IS_MATND(mat)     (CV_IS_MATND_HDR(mat) && ((const CvMatND*)(mat))->data.ptr != NULL)
#define CV_IS_SPARSE_MAT_HDR(mat)     ((mat) != NULL &&     (((const CvSparseMat*)(mat))->type & CV_MAGIC_MASK) == CV_SPARSE_MAT_MAGIC_VAL)
#define CV_IS_SPARSE_MAT(mat)     CV_IS_SPARSE_MAT_HDR(mat)
#define CV_NODE_VAL(mat,node)   ((void*)((uchar*)(node) + (mat)->valoffset))
#define CV_NODE_IDX(mat,node)   ((int*)((uchar*)(node) + (mat)->idxoffset))
#define CV_IS_HIST( hist )     ((hist) != NULL  &&      (((CvHistogram*)(hist))->type & CV_MAGIC_MASK) == CV_HIST_MAGIC_VAL &&      (hist)->bins != NULL)
#define CV_IS_UNIFORM_HIST( hist )     (((hist)->type & CV_HIST_UNIFORM_FLAG) != 0)
#define CV_IS_SPARSE_HIST( hist )     CV_IS_SPARSE_MAT((hist)->bins)
#define CV_HIST_HAS_RANGES( hist )     (((hist)->type & CV_HIST_RANGES_FLAG) != 0)
#define CV_SWAP(a,b,t) ((t) = (a), (a) = (b), (b) = (t))
#define  CV_IMIN(a, b)  ((a) ^ (((a)^(b)) & (((a) < (b)) - 1)))
#define  CV_IMAX(a, b)  ((a) ^ (((a)^(b)) & (((a) > (b)) - 1)))
#define  CV_IABS(a)     (((a) ^ ((a) < 0 ? -1 : 0)) - ((a) < 0 ? -1 : 0))
#define  CV_SIGN(a)     (((a) < 0 ? -1 : 0) | ((a) > 0))
#define  CV_INIT_3X3_DELTAS( deltas, step, nch )     ((deltas)[0] =  (nch),  (deltas)[1] = -(step) + (nch),      (deltas)[2] = -(step), (deltas)[3] = -(step) - (nch),      (deltas)[4] = -(nch),  (deltas)[5] =  (step) - (nch),      (deltas)[6] =  (step), (deltas)[7] =  (step) + (nch))
#define CV_IS_STORAGE(storage)     ((storage) != NULL &&     (((CvMemStorage*)(storage))->signature & CV_MAGIC_MASK) == CV_STORAGE_MAGIC_VAL)
#define CV_IS_SET_ELEM( ptr )  (((CvSetElem*)(ptr))->flags >= 0)
#define CV_IS_SEQ(seq)     ((seq) != NULL && (((CvSeq*)(seq))->flags & CV_MAGIC_MASK) == CV_SEQ_MAGIC_VAL)
#define CV_IS_SET(set)     ((set) != NULL && (((CvSeq*)(set))->flags & CV_MAGIC_MASK) == CV_SET_MAGIC_VAL)
#define CV_SEQ_ELTYPE( seq )   ((seq)->flags & CV_SEQ_ELTYPE_MASK)
#define CV_SEQ_KIND( seq )     ((seq)->flags & CV_SEQ_KIND_MASK )
#define CV_IS_SEQ_INDEX( seq )      ((CV_SEQ_ELTYPE(seq) == CV_SEQ_ELTYPE_INDEX) &&                                      (CV_SEQ_KIND(seq) == CV_SEQ_KIND_GENERIC))
#define CV_IS_SEQ_CURVE( seq )      (CV_SEQ_KIND(seq) == CV_SEQ_KIND_CURVE)
#define CV_IS_SEQ_CLOSED( seq )     (((seq)->flags & CV_SEQ_FLAG_CLOSED) != 0)
#define CV_IS_SEQ_CONVEX( seq )     (((seq)->flags & CV_SEQ_FLAG_CONVEX) != 0)
#define CV_IS_SEQ_HOLE( seq )       (((seq)->flags & CV_SEQ_FLAG_HOLE) != 0)
#define CV_IS_SEQ_SIMPLE( seq )     ((((seq)->flags & CV_SEQ_FLAG_SIMPLE) != 0) ||                                     CV_IS_SEQ_CONVEX(seq))
#define CV_IS_SEQ_POINT_SET( seq )     ((CV_SEQ_ELTYPE(seq) == CV_32SC2 || CV_SEQ_ELTYPE(seq) == CV_32FC2))
#define CV_IS_SEQ_POINT_SUBSET( seq )     (CV_IS_SEQ_INDEX( seq ) || CV_SEQ_ELTYPE(seq) == CV_SEQ_ELTYPE_PPOINT)
#define CV_IS_SEQ_POLYLINE( seq )     (CV_SEQ_KIND(seq) == CV_SEQ_KIND_CURVE && CV_IS_SEQ_POINT_SET(seq))
#define CV_IS_SEQ_POLYGON( seq )     (CV_IS_SEQ_POLYLINE(seq) && CV_IS_SEQ_CLOSED(seq))
#define CV_IS_SEQ_CHAIN( seq )     (CV_SEQ_KIND(seq) == CV_SEQ_KIND_CURVE && (seq)->elem_size == 1)
#define CV_IS_SEQ_CONTOUR( seq )     (CV_IS_SEQ_CLOSED(seq) && (CV_IS_SEQ_POLYLINE(seq) || CV_IS_SEQ_CHAIN(seq)))
#define CV_IS_SEQ_CHAIN_CONTOUR( seq )     (CV_IS_SEQ_CHAIN( seq ) && CV_IS_SEQ_CLOSED( seq ))
#define CV_IS_SEQ_POLYGON_TREE( seq )     (CV_SEQ_ELTYPE (seq) ==  CV_SEQ_ELTYPE_TRIAN_ATR &&     CV_SEQ_KIND( seq ) ==  CV_SEQ_KIND_BIN_TREE )
#define CV_IS_GRAPH( seq )     (CV_IS_SET(seq) && CV_SEQ_KIND((CvSet*)(seq)) == CV_SEQ_KIND_GRAPH)
#define CV_IS_GRAPH_ORIENTED( seq )     (((seq)->flags & CV_GRAPH_FLAG_ORIENTED) != 0)
#define CV_IS_SUBDIV2D( seq )     (CV_IS_SET(seq) && CV_SEQ_KIND((CvSet*)(seq)) == CV_SEQ_KIND_SUBDIV2D)
#define  CV_GET_SEQ_ELEM( elem_type, seq, index )  (   assert(sizeof((seq)->first[0]) == sizeof(CvSeqBlock) &&     (seq)->elem_size == sizeof(elem_type)),     (elem_type*)((seq)->first && (unsigned)index <     (unsigned)((seq)->first->count) ?     (seq)->first->data + (index) * sizeof(elem_type) :     cvGetSeqElem( (CvSeq*)(seq), (index), NULL )))
#define CV_WRITE_SEQ_ELEM_VAR( elem_ptr, writer ) {     if( (writer).ptr >= (writer).block_max )     {         cvCreateSeqBlock( &writer);     }     memcpy((writer).ptr, elem_ptr, (writer).seq->elem_size);     (writer).ptr += (writer).seq->elem_size; }
#define CV_WRITE_SEQ_ELEM( elem, writer ) {     assert( (writer).seq->elem_size == sizeof(elem));     if( (writer).ptr >= (writer).block_max )     {         cvCreateSeqBlock( &writer);     }     assert( (writer).ptr <= (writer).block_max - sizeof(elem));     memcpy((writer).ptr, &elem, sizeof(elem));     (writer).ptr += sizeof(elem); }
#define CV_NEXT_SEQ_ELEM( elem_size, reader ) {     if( ((reader).ptr += (elem_size)) >= (reader).block_max )     {         cvChangeSeqBlock( &(reader), 1 );     } }
#define CV_PREV_SEQ_ELEM( elem_size, reader ) {     if( ((reader).ptr -= (elem_size)) < (reader).block_min )     {         cvChangeSeqBlock( &(reader), -1 );     } }
#define CV_READ_SEQ_ELEM( elem, reader ) {     assert( (reader).seq->elem_size == sizeof(elem));     memcpy( &(elem), (reader).ptr, sizeof((elem)));     CV_NEXT_SEQ_ELEM( sizeof(elem), reader ) }
#define CV_REV_READ_SEQ_ELEM( elem, reader ) {     assert( (reader).seq->elem_size == sizeof(elem));     memcpy(&(elem), (reader).ptr, sizeof((elem)));     CV_PREV_SEQ_ELEM( sizeof(elem), reader ) }
#define CV_READ_CHAIN_POINT( _pt, reader ) {     (_pt) = (reader).pt;     if( (reader).ptr )     {         CV_READ_SEQ_ELEM( (reader).code, (*((CvSeqReader*)&(reader))));         assert( ((reader).code & ~7) == 0 );         (reader).pt.x += (reader).deltas[(reader).code][0];         (reader).pt.y += (reader).deltas[(reader).code][1];     } }
#define CV_CURRENT_POINT( reader )  (*((CvPoint*)((reader).ptr)))
#define CV_PREV_POINT( reader )     (*((CvPoint*)((reader).prev_elem)))
#define CV_READ_EDGE( pt1, pt2, reader ) {     assert( sizeof(pt1) == sizeof(CvPoint) &&             sizeof(pt2) == sizeof(CvPoint) &&             reader.seq->elem_size == sizeof(CvPoint));     (pt1) = CV_PREV_POINT( reader );     (pt2) = CV_CURRENT_POINT( reader );     (reader).prev_elem = (reader).ptr;     CV_NEXT_SEQ_ELEM( sizeof(CvPoint), (reader)); }
#define  CV_NEXT_GRAPH_EDGE( edge, vertex )      (assert((edge)->vtx[0] == (vertex) || (edge)->vtx[1] == (vertex)),       (edge)->next[(edge)->vtx[1] == (vertex)])
#define cvReshapeND( arr, header, new_cn, new_dims, new_sizes )  cvReshapeMatND( (arr), sizeof(*(header)), (header), (new_cn), (new_dims), (new_sizes))
#define cvConvert( src, dst )  cvConvertScale( (src), (dst), 1, 0 )
#define cvMatMul( srcA, srcB, dst )  cvMatMulAdd( (srcA), (srcB), NULL, (dst))
#define cvGetGraphVtx( graph, idx ) (CvGraphVtx*)cvGetSetElem((CvSet*)(graph), (idx))
#define cvGraphVtxIdx( graph, vtx ) ((vtx)->flags & CV_SET_ELEM_IDX_MASK)
#define cvGraphEdgeIdx( graph, edge ) ((edge)->flags & CV_SET_ELEM_IDX_MASK)
#define  CV_IS_GRAPH_VERTEX_VISITED(vtx)     (((CvGraphVtx*)(vtx))->flags & CV_GRAPH_ITEM_VISITED_FLAG)
#define  CV_IS_GRAPH_EDGE_VISITED(edge)     (((CvGraphEdge*)(edge))->flags & CV_GRAPH_ITEM_VISITED_FLAG)
#define CV_RGB( r, g, b )  (int)((uchar)(b) + ((uchar)(g) << 8) + ((uchar)(r) << 16))
#define CV_NEXT_LINE_POINT( iterator ) {     int mask =  (iterator).err < 0 ? -1 : 0;     (iterator).err += (iterator).minus_delta + ((iterator).plus_delta & mask);     (iterator).ptr += (iterator).minus_step + ((iterator).plus_step & mask); }
#define cvAbs( src, dst ) cvAbsDiffS( (src), (dst), cvScalarAll(0))
#define  CV_SUBDIV2D_NEXT_EDGE( edge )  (((CvQuadEdge2D*)((edge) & ~3))->next[(edge)&3])
#define cvContourPerimeter( contour ) cvArcLength( contour, CV_WHOLE_SEQ, 1 )
#define  cvCalcBackProject(img, dst, hist) cvCalcArrBackProject((CvArr**)img, dst, hist)
#define  cvCalcBackProjectPatch( img, dst, range, hist, method, normFactor )      cvCalcArrBackProjectPatch( (CvArr**)img, dst, range, hist, method, normFactor )
#define CV_COUNT_OBS(roi, win, delta, numObs ) {    (numObs)->width  =((roi)->width  -(win)->width  +(delta)->width)/(delta)->width;    (numObs)->height =((roi)->height -(win)->height +(delta)->height)/(delta)->height; }
#define CV_TURN_ON_IPL_COMPATIBILITY()     cvSetIPLAllocators( iplCreateImageHeader, iplAllocateImage, iplDeallocate, iplCreateROI, iplCloneImage )
