#! /usr/bin/env python

import sys, os, traceback
from myexceptions import LocalError

"""Strips all preprocessing directives from a C file.

If you choose to not use this program, you will be zapped by the bugs in
my code. You must also call "insert_prints.py" with the arguemnt "FULL".
"""
def stripit(cfile, stripfile, ppsfile):
    if not os.path.isfile(cfile):
        sys.exit('no such file: %s' % name)

    text = file(cfile, 'r').read()
    text = text.replace('\\\n', '')
    lines = text.splitlines()
    out = []
    pps = [len(lines)]
    for i, line in enumerate(lines):
        if line.lstrip().startswith('#'):
            out.append('')
            pps.append( (i, line) )
        else:
            out.append(line)
    out.append('')
    text = '\n'.join(out)
    file(stripfile, 'w').write(text)
    file(ppsfile, 'w').write(repr(tuple(pps)))

if __name__ == '__main__':
    if len(sys.argv) != 2:
        print >> sys.stderr, 'USAGE: ./strip_preprocs.py <filename>'
        sys.exit('USAGE: ./strip_preprocs.py <filename>')
    name = sys.argv[1]
    stripit(name, name + '.strip', name + '.pps')
